<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

class dbExport
{
	var $con;
	var $prefix;
	var $convert_to_utf8;
	
	var $fp;
	
	function dbExport(&$con,$out='php://output',$prefix=null,$convert_to_utf8=false)
	{
		$this->con = $con;
		$this->prefix = $prefix;
		$this->convert_to_utf8 = $convert_to_utf8;
		
		if (empty($out) || ($out == 'php://output' && version_compare(PHP_VERSION,'4.3','<'))) {
			$this->fp = false;
		} else {
			$this->fp = @fopen($out,'w');
		}
	}
	
	function close()
	{
		if (is_resource($this->fp)) {
			fclose($this->fp);
		}
	}
	
	function write($str)
	{
		if (is_resource($this->fp)) {
			fwrite($this->fp,$str);
		} else {
			echo $str;
		}
	}
	
	function flush()
	{
		if (is_resource($this->fp)) {
			fflush($this->fp);
		} else {
			flush();
		}
	}
	
	function export()
	{
		$tables = $this->getTables();
		
		foreach ($tables as $table)
		{
			$this->exportTable($table);
		}
	}
	
	function exportTable($table)
	{
		$cur = mysql_unbuffered_query('SELECT * FROM '.$table, $this->con->con_id);
		
		if ($this->prefix) {
			$table = preg_replace('/^'.$this->prefix.'/','',$table);
		}
		
		$res = '';
		
		if ($cur)
		{
			$i = 0;
			while ($res = mysql_fetch_row($cur))
			{
				
				if ($i == 0) {
					$args = array();
					
					for ($j=0; $j<count($res); $j++) {
						$args[] = strtolower(mysql_field_name($cur,$j));
					}
					
					$this->write("\n[".$table.' '.implode(',',$args)."]\n");
					$this->flush();
				}
				
				$fields = array();
				for ($j=0; $j<count($res); $j++)
				{
					$fields[] = $res[$j];
				}
				$this->write($this->getLine($fields));
				
				
				$i++;
			}
		}
	}
	
	function getTables()
	{
		if ($this->prefix) {
			$rs = $this->con->select("SHOW TABLES LIKE '".$this->prefix."%' ");
		} else {
			$rs = $this->con->select('SHOW TABLES');
		}
		
		$tables = array();
		
		while ($rs->fetch())
		{
			$tables[] = $rs->f(0);
		}
		
		return $tables;
	}
	
	function getLine($args)
	{
		$replacement = array(
		"\n" => '\n',
		"\r" => '\r',
		'"' => '\"'
		);
		
		if (!is_array($args)) {
			$args = func_get_args();
		}
		
		if (empty($args)) {
			return;
		}
		
		for ($i=0; $i<count($args); $i++) {
			$args[$i] = str_replace(array_keys($replacement),array_values($replacement),$args[$i]);
			
			if ($this->convert_to_utf8) {
				$args[$i] = util::latin1utf8($args[$i]);
			}
			
			$args[$i] = '"'.$args[$i].'"';
		}
		
		return implode(',',$args)."\n";
	}
}
?>