<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

require dirname(__FILE__).'/class.dbExport.php';

# Export
if (!empty($_POST['x']))
{
	header('Content-Disposition: attachment;filename=blog-backup.txt');
	header('Content-Type: text/plain; charset=UTF-8');
	
	$dbx = new dbExport($con,'php://output',DB_PREFIX,strtoupper(dc_encoding) != 'UTF-8');
	
	$dbx->write('///DOTCLEAR|'.DC_VERSION."\n");
	$dbx->write("[setting setting_id,setting_type,setting_value]\n");
	$dbx->write($dbx->getLine('dc_blog_name','string',dc_blog_name));
	$dbx->write($dbx->getLine('dc_blog_desc','string',dc_blog_desc));
	$dbx->write($dbx->getLine('dc_blog_url','string',util::getHost().dc_blog_url));
	$dbx->write($dbx->getLine('dc_app_url',	'string',dc_app_url));
	$dbx->write($dbx->getLine('dc_blog_rss','string',dc_blog_rss));
	$dbx->write($dbx->getLine('dc_blog_atom','string',dc_blog_atom));
	$dbx->write($dbx->getLine('dc_trackback_uri','string',dc_trackback_uri));
	$dbx->write($dbx->getLine('dc_img_url',	'string',dc_img_url));
	
	if (defined('dc_img_path')) {
		$dbx->write($dbx->getLine('dc_img_path','string',dc_img_path));
	} else {
		$dbx->write($dbx->getLine('dc_img_path','string',''));
	}
	$dbx->write($dbx->getLine('dc_theme','string',dc_theme));
	$dbx->write($dbx->getLine('dc_nb_post_per_page','boolean',(integer) dc_nb_post_per_page));
	$dbx->write($dbx->getLine('dc_allow_comments','boolean',(integer) dc_allow_comments));
	$dbx->write($dbx->getLine('dc_allow_trackbacks','boolean',(integer) dc_allow_trackbacks));
	$dbx->write($dbx->getLine('dc_comments_pub',	'boolean',(integer) dc_comments_pub));
	$dbx->write($dbx->getLine('dc_comments_ttl',	'boolean',(integer) dc_comments_ttl));
	$dbx->write($dbx->getLine('dc_wiki_comments','boolean',(integer) dc_wiki_comments));
	$dbx->write($dbx->getLine('dc_use_smilies','boolean',(integer) dc_use_smilies));
	$dbx->write($dbx->getLine('dc_comment_notification','boolean',(integer) dc_comment_notification));
	$dbx->write($dbx->getLine('dc_date_format','string',dc_date_format));
	$dbx->write($dbx->getLine('dc_time_format','string',dc_time_format));
	$dbx->write($dbx->getLine('dc_url_scan','string',dc_url_scan));
	$dbx->write($dbx->getLine('dc_http_cache','string',dc_http_cache));
	$dbx->write($dbx->getLine('dc_default_lang','string',dc_default_lang));
	$dbx->write($dbx->getLine('dc_upload_size','integer',dc_upload_size));
	$dbx->write($dbx->getLine('dc_show_previews','boolean',(integer) dc_show_previews));
	$dbx->write($dbx->getLine('dc_send_real_xml','boolean',(integer) dc_send_real_xml));
	$dbx->write($dbx->getLine('dc_encoding','string',dc_encoding));
	
	# Tables
	$dbx->exportTable(DB_PREFIX.'user');
	$dbx->exportTable(DB_PREFIX.'categorie');
	$dbx->exportTable(DB_PREFIX.'link');
	$dbx->exportTable(DB_PREFIX.'post');
	$dbx->exportTable(DB_PREFIX.'comment');
	
	$all_tables = $dbx->getTables();
	if (in_array(DB_PREFIX.'post_meta', $all_tables)) {
		$dbx->exportTable(DB_PREFIX.'post_meta');
	}	
	
	$dbx->close();
	exit;
}


# ---------------------------------------------------------
# Affichage
buffer::str(
'<h2>'.__('Flat file export (with metadatas)').'</h2>'
);

buffer::str(
'<p>'.__('You are about to backup your blog in a flat text file. Depending on your '.
'blog\'s size, this could take some time.').'</p>'
);

buffer::str(
'<p>'.__('What will be exported:').'</p>'.
'<ul>'.
	'<li>'.__('All entries').'</li>'.
	'<li>'.__('All comments and trackbacks').'</li>'.
	'<li>'.__('All metadatas and tags (if any)').'</li>'.
	'<li>'.__('Categories').'</li>'.
	'<li>'.__('Links').'</li>'.
	'<li>'.__('Preferences').'</li>'.
	'<li>'.__('Users').'</li>'.
'</ul>'
);

buffer::str(
'<form action="tools.php?p=flatExport" method="post">'.
'<p>'.
dcNonce::form().
'<input type="hidden" name="x" value="1" />'.
'<input type="submit" name="submit" class="submit" value="'.__('Export my blog!').'" />'.
'</p>'.
'</form>'
);
?>